import java.awt.*;
class InertBob extends Bob implements Updatable
{
	Image[] imgs=null;
	double a; //angle
	double vx=0,vy=0,va=0;
	double damper=1;

	InertBob ()	{};
	InertBob (Image[] _imgs, double _x, double _y, double _a)	
	{
		super(_imgs[0],_x,_y);
		a=_a;
		imgs=_imgs;	
		setImage(imgs,_a);
	}
	void stop()
	{
		vx=vy=va=0;
	}
	void setImages(Image[] _imgs)
	{
		imgs=_imgs;
		img=imgs[0];
	}
	void pointAt (double tx, double ty){
		a = Math.PI;
		a+= Math.atan((ty-y)/(tx-x));
		if (tx-x > 0)
			a+=Math.PI;
	}
	void aimAt(double tx, double ty){
		double wa= Math.atan((ty-y)/(tx-x))-Math.PI-a;
		if (tx>x)	wa+=Math.PI;
		//wa-=a;
		if (wa<-Math.PI)
			 wa+=Math.PI*2;
		va=wa/10.0;	
	};	
	void setDamper(double _damper) {damper=_damper;}
	double getAngle() {return a;}
	void setAngle(double _a) {a=_a; setImage(imgs, a);}
	void setVelocity(double _x, double _y, double _a) {vx=_x; vy=_y; va=_a;}
	void setForward(double speed) {setVelocity(Math.cos(a)*speed,Math.sin(a)*speed,va);}
	void accelerateForward(double speed) {	accelerate(Math.cos(a)*speed,Math.sin(a)*speed);}
	void accelerate(double _x, double _y) {vx+=_x; vy+=_y;}
	public void update(){
		move(vx,vy);
		a+=va;
		if (imgs!=null)
			setImage(imgs, a);
		if (damper<1){
			vx*=damper;
			vy*=damper;
			va*=damper;
		}
	}
}

