import java.awt.*;
import java.awt.geom.*;

class ParticleCloud extends Bob implements Updatable{
	InertBob[] parts;
	
	int lifetime=100;
	Rectangle2D.Double bounds= new Rectangle2D.Double();
	double cx, cy;

	ParticleCloud(InertBob[] particles){
		setParticles(particles);
	}	
	InertBob[] getParts(){return parts;}
	void setParticles(InertBob[] p){
		parts=p;
		for (int i=0;i<parts.length;i++)
			bounds.add(parts[i].x, parts[i].y);
		cx=bounds.getCenterX();
		cy=bounds.getCenterY();
		x=y=0;
		move(-cx,-cy);		
	}
	public void update(){
		if (!visible) return;
		lifetime--;
		int len=parts.length;
		if (lifetime==0) explode(0,0,1);
		if (lifetime<-20) setVisible(false);
		for (int i=0;i<len;i++)
			parts[i].update();
	}
	void setXY(double _x,double _y){
		double dx=_x-x, dy=_y-y;
		move (dx,dy);
		super.setXY(_x,_y);
	}
	void move(double dx,double dy){
		int len=parts.length;
		for (int i=0;i<len;i++)
			parts[i].move(dx,dy);
	}
	void draw(Graphics g){
		if (!visible) return;
		int len=parts.length;
		for (int i=0;i<len;i++){
			parts[i].draw(g);
		}
	}		
	void explode(double _x, double _y, double speed){
		for (int i=0;i<parts.length;i++){
			InertBob b=parts[i];
			double dx=b.x-_x-x ,dy=b.y-_y-y;
			dx*=speed;dy*=speed;
			b.setVelocity(dx,dy,(Math.random()-.5)*speed*10);
		}		
	}
}