import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.image.*;

public class Xanvas extends Canvas 
{
	BufferedImage backimg, bufferimg =new BufferedImage(700,500, BufferedImage.TYPE_INT_RGB);
	Graphics2D g=bufferimg.createGraphics();

	Player player=new Player();
	BobList enemies=new BobList(),
			 shots=new BobList(),
			 enemyShots=new BobList(),
			 effects=new BobList(),
			 babys=new BobList();
			 
	boolean run=false;
	int mx,my;
	int kills=0, gametime;
	boolean nextwave=true;
	boolean shoot,move;
	String cstring="2003 Paul Geisler";
	Animator animator=new Animator();
	Timer timer=new Timer();

//	Wave gwave=new TutorWave();
//	Wave gwave=new TitleWave();
//	Wave gwave=new DemoWave();
 //Wave gwave=new TestWave();
 //Wave gwave=new GameWave();
	Wave gwave=new InitWave();


	Wave wave = new GetReadyWave(gwave);
	BufferedImage getSnapshot(){
		BufferedImage img = new BufferedImage(256,256, BufferedImage.TYPE_INT_RGB);
		boolean plyvis=player.getVisible();
		player.setVisible(true);
		player.draw(g);
		player.setVisible(plyvis);
		img.createGraphics().drawImage(bufferimg,(int)-player.x+128,(int) -player.y+128, null);
  		return img;	
	}
	
	Xanvas()
	{		
		backimg=Animator.getImg("back.jpg");

		setSize(bufferimg.getWidth(),bufferimg.getHeight());
		addMouseMotionListener(new MouseMotionAdapter(){
			public void mouseMoved(MouseEvent e)	{mx=e.getX(); my=e.getY();}
			public void mouseDragged(MouseEvent e)	{mx=e.getX(); my=e.getY();}
		});
		
		addMouseListener (new MouseAdapter(){
			public void mousePressed(MouseEvent e)	{	
				if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) == 0 )	shoot=true;	
				else move=true;
			}
			public void mouseReleased(MouseEvent e) {
				if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) == 0 )	shoot=false;
				else 	move=false;
			};
		});

		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		timer.scheduleAtFixedRate(new TimerTask(){
			public void run()	{	update();}
		},1L,60L);		
	}

	public void update()	{
		if (!run) return;
		gametime--;
		//Nchste Welle einleiten
		if (wave.isWaveFinished(babys,enemies,effects,player)){
			wave=wave.getNext();
			player=wave.modifyPlayer(player);
			wave.addObjects(babys,enemies,effects,player);
			gametime=wave.getTimeLimit();
		}
		if (gametime<0){
			wave.addTimePunishment(enemies,effects,player);
			gametime=wave.getTimeLimit();			
		}
		if (babys.size()<=0)
				wave.addBabyEradicatorPunishment(babys,enemies,effects,player);			

		//Spieler
		player.move = move; player.shoot=shoot;
		player.update(shots, enemies, enemyShots, mx,my);
	
		//Spielerschsse
		Iterator i = shots.iterator();
		while (i.hasNext())
		{
			Shot s=(Shot)i.next();
			s.update();
			//"gute" Treffer
			//Iterator col = enemies.collideIterator(s);
			Bob col;
			col=enemies.collide(s);
			if (col!=null) {
				((Hitable)col).hit(effects);
				player.kills++;
				s.hit(effects); i.remove(); continue;
			}
			//traurige Treffer
			col = babys.collide(s);
			if (col!=null) {
				((Baby)col).hit(effects);
				wave.addPunishment(enemies,effects,player);
				s.hit(effects); i.remove(); babys.remove(col); continue;
			}	
			//Gegenmanahmige Treffer
			col = enemyShots.collide(s);
			if (col!=null) {
				((Shot)col).hit(effects);
				s.hit(effects); i.remove(); continue;
			}			
			if (!contains((int)s.x, (int)s.y))	i.remove();
		}

		i = enemyShots.iterator();
		while (i.hasNext()){
			Shot s=(Shot)i.next();
			if (!s.getVisible()) {i.remove(); continue;}
			if (s instanceof EffectsUpdater) ((EffectsUpdater)s).update(effects); 
			else s.update();
			if (!contains((int)s.x, (int)s.y) || !s.getVisible())
				s.setVisible(false);
			else if (s.collide (player)){
				s.hit(effects);
				player.hit(effects);				
			} 
		}
		//Feind-Aktivitt
		ListIterator zit = enemies.listIterator();	
		while (zit.hasNext()){
			Bob e=(Bob)zit.next();
			if (!e.getVisible()) {
				zit.remove();
				continue;
			}
			if (e instanceof Hitable && ((Hitable)e).collide(player)){
				((Hitable)e).hit(effects);
				player.hit(effects);
				zit.remove();	
				continue;	
			}
			// wir sind ein Zombie!
			if(e instanceof Zombie){
				Zombie z=(Zombie)e;
				z.update(effects);
				z.targeting(player, babys);
				if (z.knispel>100){					
					z.spawn(zit,effects);
					z.target.setVisible(false);
				 	babys.remove(z.target);
				}			
				if (!contains((int)z.x, (int)z.y))	{
					z.move((400-z.x)/30,(300-z.y)/30); z.va=0; z.pointAt(400,300);
				}
			}	else if (e instanceof Updatable){
				((Updatable)e).update();
				if (e instanceof Shot){
				 	if (!contains((int)e.x, (int)e.y)) e.setVisible(false);
				}
				
			}
			if (e instanceof SpawnShooter)	((SpawnShooter)e).shoot(zit,effects);			
			if (e instanceof Shooter)	((Shooter)e).shoot(enemyShots,effects);	
		}
		//optische Effekte
		i = effects.iterator();
		while (i.hasNext()){
			Updatable u =(Updatable)i.next();			
			u.update();
			if (!u.getVisible()) i.remove();
		}
		//Rendern
		if (getGraphics()!=null) paint(getGraphics());
	}
	
	public void paint(Graphics graph)
	{
		g.drawImage(backimg,0,0,this);
		babys.draw(g);
		enemies.draw(g);
		shots.draw(g);
		enemyShots.draw(g);
		player.draw(g);
		effects.draw(g);
		g.setColor(Color.white);
		g.drawString("Kills: "+player.kills+"      ENERGY: "+player.energy,20,20);		
		graph.drawImage(bufferimg,0,0,this);	
	}
}
